import info.lotosummary.software.*;
import java.io.*;

/*
segmen Java Version 1.01
To segmentalize a file.
Copyright 2016 Sogaya

JDK 1.3

*/

public class segmen {
    static final boolean WITH_COMMENTS = true;
    static final boolean WITHOUT_COMMENTS = false;
    static final int ERROR_CODE = 1;
    static final int FROM_START = 0;
    static final int LINE_COUNT = 30;
    static final String AFTER = "F";
    static final String ANCHOR = "<<";
    static final String BEFORE = "F";
    static final String EMPTY = "";
    static final String NEW_LINE = "\n";
    static final String NO_ERROR = "no error";
    static final String NO_REMOVING = "-r-";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String SEGMENT_TEXT = "segmen.txt";
    static final String SERIAL = "-l";
    static final String TEXT_FILE = ".txt";
    static final String version = "-V";
    static final String version_comments = "-VC";
    static final String WHENEVER = "-w";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";
    static final String[] day = {"00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31"};
    static final String[] hour = {" 00:", " 01:", " 02:", " 03:", " 04:", " 05:", " 06:", " 07:", " 08:", " 09:", " 10:", " 11:", " 12:", " 13:", " 14:", " 15:", " 16:", " 17:", " 18:", " 19:", " 20:", " 21:", " 22:", " 23:"};
    static final String[] minute = {"00:", "01:", "02:", "03:", "04:", "05:", "06:", "07:", "08:", "09:", "10:", "11:", "12:", "13:", "14:", "15:", "16:", "17:", "18:", "19:", "20:", "21:", "22:", "23:", "24:", "25:", "26:", "27:", "28:", "29:", "30:", "31:", "32:", "33:", "34:", "35:", "36:", "37:", "38:", "39:", "40:", "41:", "42:", "43:", "44:", "45:", "46:", "47:", "48:", "49:", "50:", "51:", "52:", "53:", "54:", "55:", "56:", "57:", "58:", "59:"};
    static final String[] month = {"-01-", "-02-", "-03-", "-04-", "-05-", "-06-", "-07-", "-08-", "-09-", "-10-", "-11-", "-12-"};
    static final String[] second = {"00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59"};

    private static void removeFiles() {
// Removing temporary files
        File file;
        String s;
        try {
            BufferedReader remove_e = new BufferedReader( new FileReader(REMOVE_ERROR_TEXT) );
            for(;;) {
                s = remove_e.readLine();
                if(s == null) {
                    break;
                } else if( WHO_TEXT.equals(s) ) {
                    continue;
                }

                file = new File(s);
                file.delete();
            }

            remove_e.close();
            file = new File(REMOVE_ERROR_TEXT);
            file.delete();
        } catch(IOException e1) {
            ;
        }

    }

    public static void main(String[] args) {
        boolean remove_first = true;
        boolean serialNumber = false;
        int period = LINE_COUNT;
        int count = args.length;
        int d;
        int errorCode = 0;
        Numbered n;
        String argument, s;
        String fileName = WHO_TEXT;
        String NEW_LINE = System.getProperty("line.separator");
        int NEW_LINE_LENGTH = NEW_LINE.length();

        for(int i = 0; i < count; ++i) {
            argument = args[i];

            if( NO_REMOVING.equals(argument) ) {
                remove_first = false;
            } else if( SERIAL.equals(argument) ) {
                serialNumber = true;
            } else if( version.equals(argument) ) {
                guide(WITHOUT_COMMENTS);
                System.exit(ERROR_CODE);
            } else if( version_comments.equals(argument) ) {
                guide(WITH_COMMENTS);
                System.exit(ERROR_CODE);
            } else {
                d = argument.indexOf(WHENEVER);
                if(d >= 0) {
                    n = new Numbered(argument);
                    period = n.number();
                    if( WHENEVER.equals( n.parameter() ) ) {
                        continue;
                    }

                    period = LINE_COUNT;
                }

                fileName = argument;
            }

        }

        if(remove_first) {
            removeFiles();
        }

        Characterizable lineType = new Consecutive(EMPTY, ANCHOR, BEFORE, AFTER);
        StringBuffer os = new StringBuffer();
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(SEGMENT_TEXT) );

            s = buffered.readLine();
            if(s == null) {
                System.exit(ERROR_CODE);
            }

            lineType = new Consecutive(s, ANCHOR, BEFORE, AFTER);
            int r = lineType.isDateLine(FROM_START);
            if(r <= 0) {
                System.err.println(s);
                System.err.println("r = lineType->isDateLine(FROM_START): r <= 0");
                System.exit(ERROR_CODE);
            }

            os.append(s);
            os.append(NEW_LINE);
            buffered.close();
        } catch(IOException e2) {
            System.err.println(SEGMENT_TEXT);
            System.exit(ERROR_CODE);
        }

        try {
            BufferedReader text = new BufferedReader( new FileReader(fileName) );

            int line = 0;
            for(;;) {
                s = text.readLine();
                if(s == null) {
                    break;
                }

                os.append(s);
                os.append(NEW_LINE);
                line += 1;
                if(line == period) {
                    s = lineType.rebuild();
                    os.append(NEW_LINE);
                    os.append(s);
                    os.append(NEW_LINE);
                    line = 0;
                }

            }

            text.close();
            String e = lineType.pileOfError();
            if(! NO_ERROR.equals(e) ) {
                System.err.print("Error");
                System.err.println(e);
            }

        } catch(IOException e3) {
            System.err.println(fileName);
            System.exit(ERROR_CODE);
        }

        String buffer = os.toString();
        TimeName wt = new TimeName(WHO, TEXT_FILE);
        String timeNameText = wt.temporaryName(serialNumber);

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(timeNameText) );
            file.write(buffer);
            file.close();
            System.out.println(timeNameText);
            System.exit(0);
        } catch(IOException e4) {
            System.err.println("IOException e4");
            System.exit(ERROR_CODE);
        }

    }

    private static void guide(boolean comments) {
        if(comments) {
            System.err.println("segmen Java Version 1.01 ");
            System.err.println("");
            System.err.println("java segmen             # Read who.txt ");
            System.err.println("java segmen -l          # serial number ");
            System.err.println("java segmen -r-         # Do not remove temporary files. ");
            System.err.println("java segmen -V          # version ");
            System.err.println("java segmen -VC         # version with comments");
            System.err.println("java segmen -w30        # Add a date line whenever 30 lines appear. ");
            System.err.println("java segmen file_name   # Read file_name. ");
        } else {
            System.err.println("segmen Java Version 1.01 ");
            System.err.println("");
            System.err.println("java segmen             ");
            System.err.println("java segmen -l          ");
            System.err.println("java segmen -r-         ");
            System.err.println("java segmen -V          ");
            System.err.println("java segmen -VC         ");
            System.err.println("java segmen -w30        ");
            System.err.println("java segmen file_name   ");
        }

    }

}
